import create from 'dd-store';
import pageStore from '../meetingDetail/store';
import { debounce, getCreateShowTime } from '../../utils/utils';
import { checkFullScren } from "../../utils/checkFullScren";
import { updateMeetingTask } from '../../api/request';

create.Page({
  store: pageStore,
  data: {
    currentTask: {},
    show: false,
    isIPX: false,
    limitClick: false
  },
  onLoad(query) {
    this.setData({
      meetingId: query.meetingId,
      isIPX: checkFullScren()
    })
  },
  inputChange: debounce(function (e) {
    const value = e.detail.value;
    this.store.data.currentTask.title = value;
    this.update();
  }, 100),
  handleExcutorChange(e) {
    //执行人页面删除执行人
    if (e.target.dataset.excutorId) {
      dd.navigateTo({ url: `/pages/excutorList/excutorList` })
    }
    //参会人列表页面选择参会人
    else {
      dd.navigateTo({ url: `/pages/attendeeList/attendeeList` })
    }
  },
  handleOpenTime() {
    this.setData({
      show: true
    })
  },
  closePopup() {
    this.setData({
      show: false
    })
  },
  onComplete(event) {
    this.store.data.currentTask.startTime = `${event.startTime}:00`;
    this.store.data.currentTask.endTime = `${event.endTime}:00`;
    this.update();
    this.closePopup();
  },
  addTask() {
    if (this.data.limitClick) {
      return
    }
    this.setData({ limitClick: true });
    const task = this.store.data.currentTask;
    updateMeetingTask({
      meetingId: this.data.meetingId,
      platform: 'dingTalk',
      taskCreateModel: {
        endTime: task.endTime ? task.endTime.replace(/\//g, '-') : '',
        title: task.title,
        innerTaskExecutorList: task.excutorId ? [task.excutor] : null
      }
    }).then(res => {
      if (res.data.code == 0) {
        //重置
        this.store.data.currentTask = {};
        this.update();

        // 修改动态列表
        if (res.data.data.length) {
          const addData = res.data.data[0].commentListDataModelList[0];
          addData.updateTime = getCreateShowTime(addData.updateTime);
          this.store.data.affairList.unshift(addData)
          dd.navigateBack();
        }
      }
      this.setData({ limitClick: false });
    })
  }
});
